杭电多校第三场1001 Problem A. Ascending Rating(单调栈处理滑动区间)

Problem A. Ascending Rating

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 524288/524288 K (Java/Others)
Total Submission(s): 533    Accepted Submission(s): 122

 

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i -th contestant's QodeForces rating is ai .
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m , say [l,l+m−1] , and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=0 and count=0 . Everytime he meets a contestant k with strictly higher rating than maxrating , he will change maxrating to ak and count to count+1 .
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count . Please write a program to figure out the answer.

Input

The first line of the input contains an integer T(1≤T≤2000) , denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD(1≤m,k≤n≤107,5≤p,q,r,MOD≤109) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD .
In the next line, there are k integers a1,a2,...,ak(0≤ai≤109) , denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k<i≤n) are then produced as follows :

ai=(p×ai−1+q×i+r)modMOD
It is guaranteed that ∑n≤7×107 and ∑k≤2×106 .

Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1] .
For each test case, you need to print a single line containing two integers A and B , where :

AB==∑i=1n−m+1(maxratingi⊕i)∑i=1n−m+1(counti⊕i)
Note that ``⊕ '' denotes binary XOR operation.

Sample Input

1 10 6 10 5 5 5 5 3 2 2 1 5 7 6 8 2 9

Sample Output

46 11

【小结】

看了标程,才知道我有多菜。

【题意】

输入那一堆东西不想说了,反正就是最后输出俩数。而且卡时间,必须线性复杂度O(n)

解法1:赛时一种很烂的思路,建议直接看解法2.

单调栈预处理出每个位置的下一个首次大于自己的位置。

dp思想预处理出每个位置最多能往后升高几次。

最后跑一遍,单调栈维护区间最值(当栈空时,说明当前区间所有数比之前区间存储的数都要小)

解法2:题解思路,太强了%%%%

从后往前扫一遍,单调栈(我更愿意说是单调队列)维护滑动区间的递减值(就像在维护一个台阶)

【代码1】

/****
***author winter2121
****/
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int mod=1e9+7;
const int MAX=1e7+5;
const int INF=0x3f3f3f3f;

int n,m,k,p,q,r,MOD,T;
int a[MAX];
int st[MAX]; //栈
int fir[MAX]; //i右边第一个大于a[i]的位置
int dp[MAX]; //以i起始的最长上坡
int main()
{
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d%d%d%d%d%d%d",&n,&m,&k,&p,&q,&r,&MOD);
        for(int i=1;i<=k;i++)scanf("%d",&a[i]);
        for(int i=k+1;i<=n;i++)a[i]=(1ll*p*a[i-1]+1ll*q*i+r)%MOD;
        int top=0;
        for(int i=1;i<=n;i++)
        {
            while(top&&a[ st[top] ]<a[i])
                fir[ st[top--] ]=i;
            st[++top]=i;
        }
        for(int i=n;i>=1;i--)dp[i]=dp[fir[i]]+1;

        top=0;
        unsigned long long ans1=0,ans2=0;
        for(int i=1,j=1;i<=n-m+1;i++)
        {
            while(top&&st[top]<i)top--;
            if(top==0)j=i; //若空,则从新开始
            while(j<=i+m-1)
            {
                if(a[j]>a[ st[top] ])st[++top]=j;
                j++;
            }
            int t=st[top];
            int Count=dp[i]-dp[t]+1;
            int maxrating=a[t];
            ans1+=maxrating^i;
            ans2+=Count^i;
        }
        printf("%llu %llu\n",ans1,ans2);
    }
}

【代码2】

#include<bits/stdc++.h>
using namespace std;
const int MAX=1e7+5;
int T,n,m,k,p,q,r,MOD,a[MAX],st[MAX];
int main()
{
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d%d%d%d%d%d%d",&n,&m,&k,&p,&q,&r,&MOD);
        for(int i=1;i<=k;i++)scanf("%d",&a[i]);
        for(int i=k+1;i<=n;i++)a[i]=(1ll*p*a[i-1]+1ll*q*i+r)%MOD;
        long long A=0,B=0;
        for(int i=n,pre=0,tail=1;i>=1;i--)
        {
            while(pre>=tail&&st[tail]>=i+m)tail++; //超出区间的部分去掉
            while(pre>=tail&&a[ st[pre] ]<=a[i])pre--; //遇到的新的更大值,之前的不需要了
            st[++pre]=i;
            if(i>n-m+1)continue;
            A+=a[ st[tail] ]^i;
            B+=(pre-tail+1)^i;
        }
        printf("%lld %lld\n",A,B);
    }
}

猜你喜欢

转载自blog.csdn.net/winter2121/article/details/81290225